////////////////////////////////////////////////////////////////////////////////
//             //                                                             //
//   #####     // Rent-a-Car Simulator                                        //
//  ######     // (!) 2013 Giovanni Squillero <giovanni.squillero@polito.it>  //
//  ###   \    //                                                             //
//   ##G  c\   //                                                             //
//   #     _\  //                                                             //
//   |   _/    //                                                             //
//   |  _/     //                                                             //
//             // 03FYZ - Tecniche di programmazione 2012-13                  //
////////////////////////////////////////////////////////////////////////////////

package bean;

public class Reservation {
	public enum VehicleClass {
		NONE, Premium_Elite, Premium, Standard, Economy
	};

	private int id;
	private int pickupDay;
	private int returnDay;
	private VehicleClass vehicleRequested;
	private VehicleClass vehicleRented;

	/* Constructors */
	public Reservation(int id) {
		this.id = id;
	}

	public Reservation(int id, int pickupDay, int returnDay, String vehicleClass) {
		this.id = id;
		setPickupDay(pickupDay);
		setReturnDay(returnDay);
		setVehicleRequested(vehicleClass);
		setVehicleRented(VehicleClass.NONE);
	}

	/* Getters/Setters */
	public void setPickupDay(int pickupDay) {
		this.pickupDay = pickupDay;
	}

	public int getId() {
		return id;
	}

	public int getPickupDay() {
		return pickupDay;
	}

	public void setReturnDay(int returnDay) {
		this.returnDay = returnDay;
	}

	public int getReturnDay() {
		return returnDay;
	}

	public void setVehicleRequested(String vehicleClass) {
		this.vehicleRequested = VehicleClass.valueOf(vehicleClass);
	}

	public void setVehicleRequested(VehicleClass vehicleClass) {
		this.vehicleRequested = vehicleClass;
	}

	public void setVehicleRented(String vehicleClass) {
		this.vehicleRented = VehicleClass.valueOf(vehicleClass);
	}

	public void setVehicleRented(VehicleClass vehicleClass) {
		this.vehicleRented = vehicleClass;
	}

	public VehicleClass getVehicleRequested() {
		return vehicleRequested;
	}

	public VehicleClass getVehicleRented() {
		return vehicleRented;
	}

	@Override
	public int hashCode() {
		return id;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Reservation other = (Reservation) obj;
		if (id != other.id)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Reservation " + id + ": " + vehicleRequested + " car from "
				+ pickupDay + " to " + returnDay + " (got " + vehicleRented
				+ ")";
	}

}
